-- ZB_DM_FXLBF ZB_DM_分险类保费
-- allxlbf/日期	险类代码
-- 1.	保单的时间口径为： 核保时间在今天并且起保时间的年份小于等于今年
-- 2.	批单的时间口径为： 核批通过时间在今天并且核批生效时间的年份小于


-- step1：
-- 团队汇总
CREATE TEMPORARY VIEW VIEW_ZB_DM_FXLBF_TUANDUI AS 
SELECT 
     s1.`uwConclueDate`                    as `uwConclueDate`
    ,s1.`risk`                             as `risk`
    ,s1.`LEVEL1COMCODE`                    as `LEVEL1COMCODE`                 
    ,s1.`LEVEL2COMCODE`                    as `LEVEL2COMCODE`                 
    ,s1.`LEVEL3COMCODE`                    as `LEVEL3COMCODE`                 
    ,s1.`LEVEL4COMCODE`                    as `LEVEL4COMCODE`                 
    ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `cost`
from ZB_ODS.ZB_ODS_KAFKA.ZBDATA s1
where     
    s1.`COMNAME` is not null
    and s1.`uwConclueDate` = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
    -- 起保时间的年份小于等于今年
    and left(s1.`startTime`,4) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyy')
group by 
    s1.`uwConclueDate`
    ,s1.`risk`
    ,s1.`LEVEL1COMCODE`                     
    ,s1.`LEVEL2COMCODE`                     
    ,s1.`LEVEL3COMCODE`                     
    ,s1.`LEVEL4COMCODE`                     
;

--总公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select 
    CONCAT(
        'allxlbf/'
        ,s1.`uwConclueDate`
    )                                       as `key` 
    ,s1.`risk`                              as `hkey`
    ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val` 
from VIEW_ZB_DM_FXLBF_TUANDUI s1
group by 
    s1.`uwConclueDate`
    ,s1.`risk`

;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select 
    CONCAT(
        'provxlbf/'
        ,s1.`uwConclueDate`
        ,'/',s1.`LEVEL1COMCODE`
    )                                       as `key`  
    ,s1.`risk`                              as `hkey` 
    ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val` 
from VIEW_ZB_DM_FXLBF_TUANDUI s1
group by 
    s1.`uwConclueDate`
    ,s1.`risk`
    ,s1.`LEVEL1COMCODE`
;

-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'cityxlbf/'
        ,s1.`uwConclueDate`
        ,'/',s1.`LEVEL2COMCODE`
        )                                    as `key`
     ,s1.`risk`                              as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_FXLBF_TUANDUI s1
group by
    s1.`uwConclueDate`
    ,s1.`risk`
    ,s1.`LEVEL2COMCODE`
;

-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countryxlbf/'
        ,s1.`uwConclueDate`
        ,'/',s1.`LEVEL3COMCODE`
        )                                    as `key`
     ,s1.`risk`                              as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_FXLBF_TUANDUI s1
group by
    s1.`uwConclueDate`
    ,s1.`risk`
    ,s1.`LEVEL3COMCODE`
;

-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamxlbf/'
        ,s1.`uwConclueDate`
        ,'/',s1.`LEVEL4COMCODE`
        )                               as `key`
     ,s1.`risk`                         as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))  as `val`
from VIEW_ZB_DM_FXLBF_TUANDUI s1
;