-- ZB_ODS_ZBDATA ZB_ODS_指标加工来源数据

insert into ZB_ODS.ZB_ODS_KAFKA.ZBDATA
select
     e1.uwConclueDate                as `uwConclueDate`                 
    ,e1.startTime                    as `startTime`                 
    ,e1.businessOffice               as `COMCODE`                 
    ,t1.COMNAME                      as `COMNAME`                 
    ,t1.LEVEL1COMCODE                as `LEVEL1COMCODE`                 
    ,t1.LEVEL2COMCODE                as `LEVEL2COMCODE`                 
    ,t1.LEVEL3COMCODE                as `LEVEL3COMCODE`                 
    ,t1.LEVEL4COMCODE                as `LEVEL4COMCODE`                 
    ,t1.LEVEL5COMCODE                as `LEVEL5COMCODE`                 
    ,t1.LEVEL1COMDESC                as `LEVEL1COMDESC`                 
    ,t1.LEVEL2COMDESC                as `LEVEL2COMDESC`                 
    ,t1.LEVEL3COMDESC                as `LEVEL3COMDESC`                  
    ,t1.LEVEL4COMDESC                as `LEVEL4COMDESC`                  
    ,t1.LEVEL5COMDESC                as `LEVEL5COMDESC`                  
    ,e1.productCode                  as `risk`                 
    ,t3.RISKNAME                     as `riskname`                 
    ,e1.businessChannelCode          as `chnl`                 
    ,e1.businessNatureCode           as `businessNatureCode`                 
    ,t4.CODEDESC                     as `businessNatureName`                 
    ,t2.NEWCHNLTYPEDESC              as `chnlname`                 
    ,e1.premium                      as `cost`                 
    ,e1.policyNo                     as `no`                 
from (
    select
         LongTimeToStringUDF(uwConclueDate,'yyyyMMdd')       as uwConclueDate        -- 核保通过时间
        ,LongTimeToStringUDF(startTime,'yyyyMMdd')           as startTime            -- 起保时间
        ,businessOffice                                        as businessOffice       -- 保单归属机构代码
        ,productCode                                           as productCode          -- 险种代码
        ,businessChannelCode                                   as businessChannelCode  -- 业务渠道
        ,businessNatureCode                                    as businessNatureCode   -- 业务来源
        ,premium                                               as premium              -- 含税保费
        ,policyNo                                              as policyNo             -- 保单号
        ,'bd'                                                  as flag			       -- 保单或批单标记	
        ,proctime                                              as proctime	 
    from ZB_ODS.ZB_SOURCE_RMQ_POLICY_SIT.POLICY 
    union all
    select
         LongTimeToStringUDF(uwConclueDate,'yyyyMMdd')       as uwConclueDate        -- 核保通过时间
        ,LongTimeToStringUDF(endorseEffectiveTime,'yyyyMMdd')as startTime            -- 起保时间
        ,businessOffice                                        as businessOffice       -- 保单归属机构代码
        ,productCode                                           as productCode          -- 险种代码
        ,businessChannelCode                                   as businessChannelCode  -- 业务渠道
        ,businessNatureCode                                    as businessNatureCode   -- 业务来源
        ,plpEndorse.staCurNetPremiumVariation                  as premium              -- 含税保费
        ,endorseNo                                             as policyNo             -- 保单号
        ,'pd'                                                  as flag			       -- 保单或批单标记	
        ,proctime                                              as proctime
    from ZB_ODS.ZB_SOURCE_RMQ_ENDOR_SIT.ENDOR
) e1
left join ZB_ODS.ZB_ODS_MYSQL.CD_COM_ALL for system_time as of e1.proctime as t1 on e1.businessOffice = t1.COMCODE
left join ZB_ODS.ZB_ODS_MYSQL.CD_NEWCHNLTYPE for system_time as of e1.proctime as t2 on e1.businessChannelCode = t2.NEWCHNLTYPE
left join ZB_ODS.ZB_ODS_MYSQL.CD_REALTIME_RISK for system_time as of e1.proctime as t3 on e1.productCode = t3.RISKCODE
left join ZB_ODS.ZB_ODS_MYSQL.CD_BUSINESSNATURE for system_time as of e1.proctime as t4 on e1.businessNatureCode = t4.CODE

;



